﻿Imports GrapeCity.ActiveReports
Imports System
Imports System.IO
Imports System.Windows.Forms
Imports GrapeCity.ActiveReports.Export.Pdf.Section
Imports System.Diagnostics

Namespace v15_MICRFont
    Public Partial Class Form1
        Inherits Form
        Public Sub New()
            InitializeComponent()
        End Sub

        Private Sub Form1_Load(sender As Object, e As EventArgs)
            Dim rpt As SectionReport1 = New SectionReport1()
            rpt.FontResolver = DirectoryFontResolver.Instance
            rpt.Run()
            viewer1.LoadDocument(rpt.Document)
            Dim exporter As PdfExport = New PdfExport()
            exporter.Export(rpt.Document, Application.StartupPath & "v16PDFExported.pdf")
            Process.Start(Application.StartupPath & "v16PDFExported.pdf")
        End Sub
    End Class
    Public NotInheritable Class DirectoryFontResolver
        Implements IFontResolver
        Private Shared ReadOnly _fonts As GrapeCity.Documents.Text.FontCollection = New GrapeCity.Documents.Text.FontCollection()
        Shared Sub New()
            Dim projectFolder = Path.GetFullPath("..\..\")
            _fonts.RegisterDirectory(projectFolder)
            _fonts.DefaultFont = _fonts.FindFamilyName("Arial")
        End Sub
        Public Shared Instance As IFontResolver = New DirectoryFontResolver()
        Private Sub New()
        End Sub

        Private Function GetFonts(familyName As String, isBold As Boolean, isItalic As Boolean) As GrapeCity.Documents.Text.FontCollection Implements IFontResolver.GetFonts
            Dim fonts = New GrapeCity.Documents.Text.FontCollection()
            Dim font = _fonts.FindFamilyName(familyName, isBold, isItalic)
            If font IsNot Nothing Then fonts.Add(font)
            fonts.Add(_fonts.DefaultFont)
            Return fonts
        End Function
    End Class
End Namespace
